/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package listas;

import excepciones.ExcepcionIndiceFueraDelIntervaloValido;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author mariano
 * @param <T>
 */
public class MiArrayList<T> {

    protected int tam = 0;
    protected int tamMax = 100;
    
    //Para no tener problemas con conversión automática que realiza Java con las
    //clases genéricas, manejo los elementos como objetos y, cuando tengo que
    //devolver alguno, fuerzo la conversión a T (véase, p.ej., el método get.
    protected Object[] array = new Object[tamMax];

    public boolean isEmpty() {
        return tam == 0;
    }

    public void add(T e) {
        if (tam == tamMax) {
            tamMax = tamMax * 2;
            T[] arrayAux = (T[]) new Object[tamMax];
            System.arraycopy(array, 0, arrayAux, 0, array.length);
            array = arrayAux;
            array[tam++] = e;

        }
        array[tam++] = e;
    }

    T get(int i) {
        try {
            if (i < 0 || i >= tam) {
                throw new ExcepcionIndiceFueraDelIntervaloValido("Índice fuera del intervalo válido");
            }
            return (T) array[i];
        } catch (ExcepcionIndiceFueraDelIntervaloValido ex) {
            Logger.getLogger(MiArrayList.class.getName()).log(Level.SEVERE, null, ex);
        }

        return null;
    }

    public void remove(T e) {
        boolean encontrado = false;
        int i = 0;
        while (!encontrado && i < tam) {
            encontrado = e.equals(array[i++]);
        }

        if (encontrado) desplazarEltos(i - 1);
    }

    private void desplazarEltos(int i) {
        for (int j = i; j < tam; j++) {
            array[j] = array[j + 1];
        }

        tam--;
    }

    public boolean contains(T e) {
        boolean encontrado = false;
        int i = 0;
        while (!encontrado && i < tam) {
            encontrado = e.equals(array[i++]);
        }

        return encontrado;
    }

    public int size() {
        return tam;
    }

}
