/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package listas;

/**
 *
 * @author mariano
 */
public class MiArrayListDeEnteros extends MiArrayList<Integer> {

    public boolean equals(MiArrayListDeEnteros listaEnteros)
    {
        boolean puedenSerIguales = (this.isEmpty()==listaEnteros.isEmpty());
        int i = 0;
        while(puedenSerIguales && i < size())
        {
            puedenSerIguales = this.get(i) == listaEnteros.get(i);
            i++;
        }
        
        return puedenSerIguales;
    }
    
    public void sort() {
        for(int i = 0; i < tam ; i++)
        {
            intercambiarConMinimoDesdeIndice(i);
        }
        
    }
    
    
    //Ejemplos de ejecución de este método:
    
    //EJEMPLO 1. Si se aplica a [3, 4, 5, 8, 1, 3, 1] a partir del índice 0, se 
    // obtiene [1, 4, 5, 8, 3, 3, 1]. Como se puede observar, el elemento del
    // lugar 0 (el 3) se ha intercambiado por la primera ocurrencia del 1 
    // (que es el elemento con valor mínimo en el array).

    //EJEMPLO 2. Si se aplica a [1, 1, 5, 8, 3, 3, 4] a partir del índice 2, se 
    // obtiene [1, 1, 3, 8, 5, 3, 4]. Como se puede observar, el elemento del 
    // lugar 2 (el 5) se ha intercambiado por la primera ocurrencia del 3
    // (que es el elemento con valor mínimo a partir del lugar 2).
    
    private void intercambiarConMinimoDesdeIndice(int indice)
    {
        //Se inicializan los valores de mínimo y de índiceDelMínimo. Ésta
        //última variable se utiliza para saber dónde está el valor mínimo
        //dentro del array.
        Integer minimo = (Integer) array[indice];
        int indiceDelMinimo = indice;
        
        //Se recorre el array buscando el mínimo
        for(int i = indice; i < tam; i++)
        {
            //Si el elemento por el que vamos es menor que mínimo actual, 
            //entonces dicho elemento pasa a ser el mínimo, y su índice el
            //índiceDelMínimo.
            Integer elemento = (Integer) array[i];
            if (minimo.compareTo(elemento) > 0)
            {
                minimo = (Integer) array[i];
                indiceDelMinimo = i;
            }
        }
        
        //Se realiza el intercambio.
        int aux = (Integer) array[indiceDelMinimo];
        array[indiceDelMinimo] = array[indice];
        array[indice] = aux;
    }
    
}
